/*
* Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved. 
 *
 * Project:    TimesTen Driver Manager
 * Version:    1.9
 * Date:       6th January 2010
 * Author:     chris.jenkins@oracle.com
 *
 * This is the header file for the TimesTen Driver Manager (ttdrvmgr).
 * Applications that use the DM can include it if they wish to do so but
 * it is not essential.
 */

#ifndef _TT_DRVMGR_H
#define _TT_DRVMGR_H

#include <timesten.h>

/*
 * Additional native error codes
 */
#define    tt_ErrDMNoMemory        50000
#define    tt_ErrDMDriverLoad      50001
#define    tt_ErrDMNotDisconnected 50002
#define    tt_ErrDMInvalidArg      50003

/*
 * TTDM specific option and return values for SQLGetConnectOption
 */

#define    TTDM_CONNECTION_TYPE    (SQL_CONNECT_OPT_DRVR_START+1000)

#define    TTDM_CONN_NONE          0
#define    TTDM_CONN_DIRECT        1
#define    TTDM_CONN_CLIENT        2

#endif
